from turtle import *
from random import randint
import turtle
import random

"""
Ce fichier est expliqué ici : https://nsi.xyz/py2png
Un autre tutoriel permet de commencer : https://nsi.xyz/tutoriels/decouvrir-le-module-turtle-de-python/
"""

try:
    from PIL import Image
    pillow_installed = True
except:
    print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
    print("https://nsi.xyz/py2png")
    pillow_installed = False

# Uniquement des lettres, des chiffres, un tiret. Rien d'autre.
# https://learn.microsoft.com/fr-fr/windows/win32/fileio/naming-a-file
titre = "etoiles 9 branches - construite avec turtle"

# Définir le titre de la fenêtre de turtle + propagande ^^
title(titre+" | Au lycée, la meilleure spécialité, c'est la spé NSI")

# definir la taille de la fenêtre en 720p (Largeur, Hauteur)
# La tortue part du centre, au point de coordonnées (0,0)
setup(1280, 720)

# La tortue va à la vitesse du lièvre et active sa cape d'invisibilité
speed(0)
hideturtle()

# ============== MON SCRIPT PYTHON ==============


import turtle
import random

turtle.speed(0)
turtle.goto(-760,400)
turtle.pensize(10)
turtle.right(90)
for i in range(75):
    turtle.forward(420*2)
    turtle.left(90)
    turtle.forward(10)
    turtle.left(90)
    turtle.forward(420*2)
    turtle.right(90)
    turtle.forward(10)
    turtle.right(90)
    
def etoiles(branches, longueur):
    turtle.begin_fill()
    turtle.fillcolor("white")
    for i in range(branches):
        turtle.forward(longueur)
        turtle.right(180+180/branches)
        turtle.forward(longueur)
        turtle.left(180-180/branches)
    turtle.end_fill()

# Fonction qui trace une orbite (ellipse)
def orbite(rayon):
  turtle.seth(-45) 
  for i in range(2):
      turtle.circle(rayon,90)
      turtle.circle(rayon/2,90)
  return()
# Fonction qui affiche la texture d'une balle
def surface(couleur,rayon,posx,posy):
    r=couleur[0]
    g=couleur[1]
    b=couleur[2]
    turtle.pensize(5)
    for i in range(51):
        turtle.home()
        turtle.goto(posx,posy)
        turtle.pendown()
        if ((r-i*1.5)>=0) and ((g-i*1.5)>=0) and ((b-i*1.5)>=0):
            r1=r-i*1.5; g1=g-i*1.5; b1=b-i*1.5;
        elif ((r-i*1.5)<0): r1=r
        elif ((g-i*1.5)<0): g1=g
        else: b1=b
        turtle.pencolor((r1/255,g1/255,b1/255))
        turtle.circle((100-2*i)*rayon)
        turtle.penup()
#Tracé du ciel étoilé
turtle.pensize(1)
for i in range(150):
   turtle.penup()
   turtle.goto(random.randint(-640,640),random.randint(-350,350))
   turtle.pencolor("black")
   turtle.pendown()
   a=random.randint(1,5)
   if a<2:
      turtle.begin_fill()
      turtle.fillcolor("white")
      turtle.circle(a)
      turtle.end_fill()
   else:
      turtle.begin_fill()
      turtle.fillcolor("#e1e1df")
      turtle.circle(a)
      turtle.end_fill()
#Dessine une ballon de basket centre de rayon 100r      
r=.7
turtle.home()      
turtle.begin_fill()
turtle.fillcolor("coral")
turtle.goto(0,-50*r)
turtle.circle(100*r)
turtle.end_fill()
turtle.penup()
surface([255,127,80],r,0,-50*r)
turtle.goto(-100*r,50*r)
turtle.left(0)
turtle.pendown()
turtle.pensize(5*r)
turtle.pencolor("black")
turtle.forward(200*r)
turtle.penup()
turtle.goto(0,150*r)
turtle.right(90)
turtle.pendown()
turtle.forward(200*r)
turtle.penup()
turtle.goto(-50*r,50*r)
turtle.left(180)
turtle.pendown()
turtle.circle(100*r)
turtle.penup()
turtle.goto(50*r,50*r)
turtle.right(180)
turtle.pendown()
turtle.circle(100*r)
turtle.penup()
turtle.pensize(5*r)
#Tracé des orbites orbite
orbites=[[-250*r,-80*r,250],[-350*r,-130*r,350],[-450*r,-180*r,450]]
for m in orbites:
  turtle.home()
  turtle.penup()
  turtle.pencolor("white")
  turtle.goto(m[0],m[1])
  turtle.pendown()
  turtle.pensize(2)
  orbite(m[2])
  turtle.penup()
#Tracé de la balle de tennis
turtle.home()
turtle.goto(-200,25)
turtle.bgcolor("black")
turtle.begin_fill()
turtle.fillcolor("#dfff4f")
turtle.circle(40)
turtle.end_fill()
turtle.penup()
surface([223,255,79],.38,-200,25)
turtle.goto(-180,35)
turtle.left(90)
turtle.pendown()
turtle.pensize(7)
turtle.pencolor("white")
turtle.forward(60)
turtle.penup()
turtle.goto(-220,35)
turtle.pendown()
turtle.forward(60)
turtle.penup()
#Tracé balle de baseball
turtle.home()
turtle.hideturtle()
turtle.bgcolor("black")
turtle.pencolor
turtle.begin_fill()
turtle.fillcolor("white")
turtle.goto(270,-100)
turtle.circle(50)
turtle.end_fill()
turtle.penup()
surface([255,255,255],.46,270,-100)
turtle.goto(245,-90)
turtle.pendown()
turtle.left(90)
turtle.pencolor("red")
turtle.pensize(5)
turtle.forward(80)
turtle.pensize(4)
for i in range(8):
    turtle.backward(10)
    turtle.left(45)
    turtle.forward(7)
    turtle.backward(7)
    turtle.right(90)
    turtle.forward(7)
    turtle.backward(7)
    turtle.left(45)
turtle.penup()
turtle.goto(295,-90)
turtle.right(90)
turtle.pendown()
turtle.left(90)
turtle.pencolor("red")
turtle.forward(80)
for i in range(8):
    turtle.backward(10)
    turtle.left(45)
    turtle.forward(7)
    turtle.backward(7)
    turtle.right(90)
    turtle.forward(7)
    turtle.backward(7)
    turtle.left(45)
turtle.penup()
turtle.goto(295,160)
turtle.pendown()
turtle.seth(0)
turtle.pencolor("brown")
turtle.speed(0)
turtle.left(50)
turtle.begin_fill()
turtle.fillcolor("brown")
for i in range(100):
    turtle.forward(2)
    turtle.right(1)
turtle.right(80)
for i in range(100):
    turtle.forward(2)
    turtle.right(1)
turtle.end_fill()
turtle.right(130)
turtle.penup()
turtle.forward(30)
turtle.pendown()
turtle.pencolor("white")
turtle.pensize(3)
turtle.forward(120)
turtle.right(180)
for i in range(6):
    turtle.forward(18)
    turtle.right(90)
    turtle.forward(10)
    turtle.backward(20)
    turtle.forward(10)
    turtle.left(90)
turtle.pencolor("white")
turtle.penup()
turtle.goto(550,300)
turtle.pendown()
etoiles(5,80)
turtle.penup()
turtle.goto(-540,-290)
turtle.pendown()
etoiles(7,60)

 
 



# ============== GENERER DES IMAGES AUTOMATIQUEMENT ==============

image = getcanvas()
nom_du_fichier_sans_extension=titre+"_"+hex(randint(2**30+2**25,2**30+2**25+2**24-1))[2:]

# Génère un fichier .ps
image.postscript(file=nom_du_fichier_sans_extension+".ps", colormode='color')

# Ouvre le fichier .ps et génère le fichier .png


try:
    psimage = Image.open(nom_du_fichier_sans_extension+".ps")
    psimage.load(scale=2)
    psimage_resized = psimage.resize((1280, 720))
    psimage.save(nom_du_fichier_sans_extension+".png")
    print(nom_du_fichier_sans_extension+".png", psimage.size, "sauvegardé dans le dossier")    
    
except:
    if not pillow_installed:
        print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
        print("https://nsi.xyz/py2png")
    else:
        print("Oops! - 'ghostscript' not installed- RTFM :")
        print("https://nsi.xyz/py2png")

exitonclick()
